# ==================================================================
# Plugins::GForum::Subscribe - Auto Generated Program Module
#
#   Plugins::GForum::Subscribe
#   Author  : Joe Tan
#   Version : 1
#   Updated : Thu Feb 20 23:18:35 2003
#
# ==================================================================
#

package Plugins::GForum::Subscribe;
# ==================================================================

use strict;
use GT::Base;
use GT::Plugins qw/STOP CONTINUE/;
use GForum qw/:forum $IN $DB $CFG $USER/;

# Inherit from base class for debug and error methods
@Plugins::GForum::Subscribe::ISA = qw(GT::Base);

# Your code begins here! Good Luck!


# PLUGIN HOOKS
# ===================================================================


sub add_subscription {
	my $update = $IN->param('update');
	if ($update) {
		my $forum_id = $IN->param('forum');
	    my %subscribed = map { ($_->[0] => 1) } @{$DB->table('ForumSubscriber')->select(forum_id_fk => { user_id_fk => $USER->{user_id} })->fetchall_arrayref};
	    require GForum::Authenticate;
		if (GForum::Authenticate::auth('forum_permission', $forum_id) >= FORUM_PERM_READ ) {
			unless ($subscribed{$forum_id}) {
				$DB->table('ForumSubscriber')->insert({ forum_id_fk => $forum_id, user_id_fk => $USER->{user_id}, subsc_time => time, subsc_last => undef });
			}
		}

	    $GForum::Template::VARS{changes_saved} = 1;
	    GForum::do_func($IN->param('next_do'));
		GT::Plugins->action ( STOP );
	} else {
		GT::Plugins->action( CONTINUE );
	}
}

# same as above, except jump to thankyou page
sub add_subscription_thankyou {
    my $self = shift;
    my ($do, $func) = @_;
    my $page = $func->{page};

	my $forum_id = $IN->param('forum');

    my %subscribed = map { ($_->[0] => 1) } @{$DB->table('ForumSubscriber')->select(forum_id_fk => { user_id_fk => $USER->{user_id} })->fetchall_arrayref};
    require GForum::Authenticate;
	my $status = '';
	if (GForum::Authenticate::auth('forum_permission', $forum_id) >= FORUM_PERM_READ ) {
		unless ($subscribed{$forum_id}) {
			$DB->table('ForumSubscriber')->insert({ forum_id_fk => $forum_id, user_id_fk => $USER->{user_id}, subsc_time => time, subsc_last => undef });
			$status = 'subscribe';
		} else {
			$status = 'exist';
		}
	}

	my $sth = $DB->table('Forum')->select( {forum_id => $forum_id} )->fetchrow_hashref;
	
	return (
		$page->{thankyou} => { status => $status, forum_id => $forum_id, forum_name => $sth->{forum_name} }
	);

}

# Always end with a 1.
1;
